zmija = {{x,y}}
n=1
t=0
vx=0
vy=-100
g=1.3
mx=0
my=0
circ=false
cR=0
mz=1
mC=0
R=0
vterm=500
phi=0
dx=0
deltat=0
hrana={x,y,r}
ki=false
function love.load()
  love.graphics.setCaption("Gravity snakes")
  love.graphics.setColor(255,255,255)
  zmija[1].x = love.graphics.getWidth()/2
  zmija[1].y = love.graphics.getHeight()/2
  bgm= love.audio.newSource("bgm.mp3")
  bgm:setLooping(true)
  bgm:play()
  hrana.r = math.random(15,75)
  hrana.x = math.random(0+hrana.r, love.graphics.getWidth() - hrana.r)
  hrana.y = math.random(0+hrana.r, love.graphics.getHeight() - hrana.r)
  love.graphics.setBackgroundColor(55,55,55,55)
end 

function love.draw()
  if ki then
    fnt=love.graphics.newFont(50)
    love.graphics.setFont(fnt)
    love.graphics.print("GAME OVER",250,230)
    love.graphics.print ("SCORE:"..n-1,250,280)
  else
    love.graphics.setColor(255,255,255,255)
    for i=1,n do
      love.graphics.circle("fill",zmija[i].x,zmija[i].y,3)
    --  love.graphics.draw(zmi,zmija[i].x,zmija[i].y,math.atan2(vy,vx)+math.pi/2)
      
    end
   --[[ love.graphics.print(vx,10,0)
    love.graphics.print(vy,10,50)
    love.graphics.print(cR,10,100)
    love.graphics.print(R,10,150)
    love.graphics.print (phi,10,200)
    love.graphics.print (dx,10,250)
    love.graphics.print (deltat,10,300) ]]--
    love.graphics.print (n,10,0)
    love.graphics.setColor(30,179,178,255)
    love.graphics.circle("fill",hrana.x,hrana.y,hrana.r)
    if circ==true then
      love.graphics.setColor(118,164,82,255)
      love.graphics.circle("fill",mx,my,cR)
    end
  end
 end
 
function love.update(dt)
  if not ki then
    if love.mouse.isDown("l") then
      X=love.mouse.getX()
      Y=love.mouse.getY()
      circ=true
      R= math.sqrt((zmija[1].x - mx)*(zmija[1].x - mx)+(zmija[1].y - my)*(zmija[1].y - my))
      cR=math.sqrt((X-mx)*(X-mx)+(Y-my)*(Y-my)) --radius of planet
      phi= math.atan2((zmija[1].y-my),(zmija[1].x-mx)) --angle between snake's head and x axle trough center of the planet
      mC=cR*2 --mass of planet
      g=(mC/(R*R))*50000 -- gravity acceleration
      vx=vx-g*math.cos(phi)*dt --vertical component of speed
      vy=vy-g*math.sin(phi)*dt --horizontal component of speed
    end
    --ovo sledece je za hranu
    hranar=math.sqrt((zmija[1].x-hrana.x)*(zmija[1].x-hrana.x)+(zmija[1].y-hrana.y)*(zmija[1].y-hrana.y))
    if hranar*hranar < hrana.r*hrana.r then
      pup=love.audio.newSource("pup.wav","static")      
      love.audio.play(pup)
      hrana.r = math.random(15,75)
      hrana.x = math.random(0+hrana.r, love.graphics.getWidth() - hrana.r)
      hrana.y = math.random(0+hrana.r, love.graphics.getHeight() - hrana.r)
      n=n+1
      table.insert(zmija,n,{x,y})
      zmija[n].x=0
      zmija[n].y=0
    end
    --dotle ide hrana
    if vx > vterm then
      vx=vterm
    elseif vx< -vterm then
      vx=-vterm
    end
    if vy > vterm then
      vy=vterm
    elseif vy< -vterm then
      vy=-vterm
    end
    for i=1,n do
      if zmija[i].x < 0 then
        zmija[i].x = love.graphics.getWidth()
      elseif zmija[i].x > love.graphics.getWidth() then
        zmija[i].x = 0
      end
      if zmija[i].y < 0 then
        zmija[i].y = love.graphics.getHeight()
      elseif zmija[i].y > love.graphics.getHeight() then
        zmija[i].y=0
      end
    end
    if R*R<cR*cR then
      crash=love.audio.newSource("crash.wav","static")
      love.audio.play(crash)
      ki=true
    end
    dx=zmija[1].y
    if n > 1 then
      for i=n,2,-1 do
        zmija[i].x=zmija[i-1].x 
        zmija[i].y=zmija[i-1].y 
      --zmija[i].x=zmija[i].x+ vx*dt
      --zmija[i].y=zmija[i].y+ vy*dt
      end
    end
    zmija[1].x=zmija[1].x+ vx*dt
    zmija[1].y=zmija[1].y+ vy*dt
    dx=math.abs(dx-zmija[1].y)
    deltat=dt
    t=t+dt
  end
end

function love.mousereleased(x,y,button)
  t=0
  circ=false
end
function love.mousepressed(x,y,button)
  mx=x
  my=y
end
